#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <signal.h>

#define FILENAME_MAXLEN 50
#define LINE_MAXLEN 50

/* Worker in charge of count the number of lines of a files chunk. */
/* Parameters =  1)path file including the files paths to be processed;
                 2)worker id  
                 3)chunk size
                 4)path file of the result file */
int main(int argc, char * argv[]){
  FILE *files_f = NULL, *f = NULL, *result_f = NULL;
  char filename[FILENAME_MAXLEN];
  char line[LINE_MAXLEN];
  int id = 0, chunk_size = 0, offset = 0, cpt_lines = 0, i = 0;
  
  /* Open the files file */
  files_f = fopen(argv[1], "r");
  id= atoi(argv[2]);
  chunk_size = atoi(argv[3]);
  offset = id * chunk_size;

  printf("Decompte local %d démarre\n", id);

  /* and offset the file descriptor to the specified chunk */
  while(i < offset && fgets(line, FILENAME_MAXLEN, files_f) != NULL ){
    i++;
  }
  
  printf("Decompte local %d décalé de %i, prêt à traiter %d fichiers\n", id, i, chunk_size);

  /* For each file to process, ... */
  for (i = 0; i < chunk_size; i++){
    fgets(filename, FILENAME_MAXLEN, files_f);

    filename[strlen(filename) - 1]='\0';

    /* ... count the number of its lines */
    f = fopen(filename, "r");    
    while(fgets(line, LINE_MAXLEN, f) != NULL){
      cpt_lines++;
    }
    fclose(f);
  }

  printf("Decompte local %d a lu %d lines\n", id, cpt_lines);

  /* TODO Q2.c - 2 pts : write at the rigth place, the result */




  
  fclose(files_f);
  return EXIT_SUCCESS;
}
